import pandas as pd
import numpy as np


def output_1_remove_existing_index_and_make_new_one():
    df = pd.DataFrame(
        {
            "uid": {
                0: 1,
                1: 1,
                2: 2,
                3: 3,
                4: 4,
                5: 5,
                6: 6,
                7: 7,
                8: 8,
                9: 9,
                10: 10,
                11: 11,
                12: 12,
                13: 13,
                14: 14,
                15: 15,
                16: 16,
            },
            "date": {
                0: pd.to_datetime("2019-12-31 00:00:00"),
                1: pd.to_datetime("2019-12-31 00:00:00"),
                2: pd.to_datetime("2020-03-31 00:00:00"),
                3: pd.to_datetime("2020-03-31 00:00:00"),
                4: pd.to_datetime("2020-03-31 00:00:00"),
                5: pd.to_datetime("2020-03-31 00:00:00"),
                6: pd.to_datetime("2020-06-30 00:00:00"),
                7: pd.to_datetime("2020-06-30 00:00:00"),
                8: pd.to_datetime("2020-06-30 00:00:00"),
                9: pd.to_datetime("2020-09-30 00:00:00"),
                10: pd.to_datetime("2020-09-30 00:00:00"),
                11: pd.to_datetime("2020-09-30 00:00:00"),
                12: pd.to_datetime("2020-09-30 00:00:00"),
                13: pd.to_datetime("2020-12-31 00:00:00"),
                14: pd.to_datetime("2020-12-31 00:00:00"),
                15: pd.to_datetime("2020-12-31 00:00:00"),
                16: pd.to_datetime("2020-12-31 00:00:00"),
            },
            "id": {
                0: "A",
                1: "A",
                2: "A",
                3: "B",
                4: "C",
                5: "na",
                6: "A",
                7: "E",
                8: "B",
                9: "A",
                10: "F",
                11: "B",
                12: "C",
                13: "A",
                14: "B",
                15: "C",
                16: "G",
            },
            "desc": {
                0: "this is A",
                1: "this is A",
                2: "this is A",
                3: "this is B",
                4: "this is C",
                5: "",
                6: "this is A",
                7: "this is E",
                8: "this is B",
                9: "this is A",
                10: "this is F",
                11: "this is B",
                12: "this is C",
                13: "this is A",
                14: "this is B",
                15: "this is C",
                16: "this is G",
            },
            "value": {
                0: 5.0,
                1: 5.0,
                2: 10.0,
                3: 20.0,
                4: 30.0,
                5: 40.0,
                6: np.nan,
                7: 17.0,
                8: 20.0,
                9: 10.0,
                10: 20.0,
                11: 20000000.0,
                12: 30.0,
                13: 10.0,
                14: 20.0,
                15: 30.0,
                16: 100.0,
            },
            "volume": {
                0: 1.0,
                1: 1.0,
                2: 2.0,
                3: 4.0,
                4: 6.0,
                5: 8.0,
                6: np.nan,
                7: 3.0,
                8: 4.0,
                9: 2.0,
                10: 4.0,
                11: np.nan,
                12: 6.0,
                13: 2.0,
                14: 4.0,
                15: 6.0,
                16: 10.0,
            },
            "random": {
                0: 1.0,
                1: 1.0,
                2: 1.0,
                3: 1.0,
                4: 1.0,
                5: 1.0,
                6: np.nan,
                7: 1.0,
                8: 1.0,
                9: 1.0,
                10: 1.0,
                11: np.nan,
                12: 1.0,
                13: 1.0,
                14: 1.0,
                15: 1.0,
                16: 1.0,
            },
        }
    )
    return df


def output_1_drop_duplicate_rows():
    df = pd.DataFrame(
        {
            "uid": {
                0: 1,
                2: 2,
                3: 3,
                4: 4,
                5: 5,
                6: 6,
                7: 7,
                8: 8,
                9: 9,
                10: 10,
                11: 11,
                12: 12,
                13: 13,
                14: 14,
                15: 15,
                16: 16,
            },
            "date": {
                0: pd.to_datetime("2019-12-31 00:00:00"),
                2: pd.to_datetime("2020-03-31 00:00:00"),
                3: pd.to_datetime("2020-03-31 00:00:00"),
                4: pd.to_datetime("2020-03-31 00:00:00"),
                5: pd.to_datetime("2020-03-31 00:00:00"),
                6: pd.to_datetime("2020-06-30 00:00:00"),
                7: pd.to_datetime("2020-06-30 00:00:00"),
                8: pd.to_datetime("2020-06-30 00:00:00"),
                9: pd.to_datetime("2020-09-30 00:00:00"),
                10: pd.to_datetime("2020-09-30 00:00:00"),
                11: pd.to_datetime("2020-09-30 00:00:00"),
                12: pd.to_datetime("2020-09-30 00:00:00"),
                13: pd.to_datetime("2020-12-31 00:00:00"),
                14: pd.to_datetime("2020-12-31 00:00:00"),
                15: pd.to_datetime("2020-12-31 00:00:00"),
                16: pd.to_datetime("2020-12-31 00:00:00"),
            },
            "id": {
                0: "A",
                2: "A",
                3: "B",
                4: "C",
                5: "na",
                6: "A",
                7: "E",
                8: "B",
                9: "A",
                10: "F",
                11: "B",
                12: "C",
                13: "A",
                14: "B",
                15: "C",
                16: "G",
            },
            "desc": {
                0: "this is A",
                2: "this is A",
                3: "this is B",
                4: "this is C",
                5: "",
                6: "this is A",
                7: "this is E",
                8: "this is B",
                9: "this is A",
                10: "this is F",
                11: "this is B",
                12: "this is C",
                13: "this is A",
                14: "this is B",
                15: "this is C",
                16: "this is G",
            },
            "value": {
                0: 5.0,
                2: 10.0,
                3: 20.0,
                4: 30.0,
                5: 40.0,
                6: np.nan,
                7: 17.0,
                8: 20.0,
                9: 10.0,
                10: 20.0,
                11: 20000000.0,
                12: 30.0,
                13: 10.0,
                14: 20.0,
                15: 30.0,
                16: 100.0,
            },
            "volume": {
                0: 1.0,
                2: 2.0,
                3: 4.0,
                4: 6.0,
                5: 8.0,
                6: np.nan,
                7: 3.0,
                8: 4.0,
                9: 2.0,
                10: 4.0,
                11: np.nan,
                12: 6.0,
                13: 2.0,
                14: 4.0,
                15: 6.0,
                16: 10.0,
            },
            "random": {
                0: 1.0,
                2: 1.0,
                3: 1.0,
                4: 1.0,
                5: 1.0,
                6: np.nan,
                7: 1.0,
                8: 1.0,
                9: 1.0,
                10: 1.0,
                11: np.nan,
                12: 1.0,
                13: 1.0,
                14: 1.0,
                15: 1.0,
                16: 1.0,
            },
        }
    )
    return df


def output_1_drop_columns():
    df = pd.DataFrame(
        {
            "uid": {
                0: 1,
                2: 2,
                3: 3,
                4: 4,
                5: 5,
                6: 6,
                7: 7,
                8: 8,
                9: 9,
                10: 10,
                11: 11,
                12: 12,
                13: 13,
                14: 14,
                15: 15,
                16: 16,
            },
            "date": {
                0: pd.to_datetime("2019-12-31 00:00:00"),
                2: pd.to_datetime("2020-03-31 00:00:00"),
                3: pd.to_datetime("2020-03-31 00:00:00"),
                4: pd.to_datetime("2020-03-31 00:00:00"),
                5: pd.to_datetime("2020-03-31 00:00:00"),
                6: pd.to_datetime("2020-06-30 00:00:00"),
                7: pd.to_datetime("2020-06-30 00:00:00"),
                8: pd.to_datetime("2020-06-30 00:00:00"),
                9: pd.to_datetime("2020-09-30 00:00:00"),
                10: pd.to_datetime("2020-09-30 00:00:00"),
                11: pd.to_datetime("2020-09-30 00:00:00"),
                12: pd.to_datetime("2020-09-30 00:00:00"),
                13: pd.to_datetime("2020-12-31 00:00:00"),
                14: pd.to_datetime("2020-12-31 00:00:00"),
                15: pd.to_datetime("2020-12-31 00:00:00"),
                16: pd.to_datetime("2020-12-31 00:00:00"),
            },
            "id": {
                0: "A",
                2: "A",
                3: "B",
                4: "C",
                5: "na",
                6: "A",
                7: "E",
                8: "B",
                9: "A",
                10: "F",
                11: "B",
                12: "C",
                13: "A",
                14: "B",
                15: "C",
                16: "G",
            },
            "desc": {
                0: "this is A",
                2: "this is A",
                3: "this is B",
                4: "this is C",
                5: "",
                6: "this is A",
                7: "this is E",
                8: "this is B",
                9: "this is A",
                10: "this is F",
                11: "this is B",
                12: "this is C",
                13: "this is A",
                14: "this is B",
                15: "this is C",
                16: "this is G",
            },
            "value": {
                0: 5.0,
                2: 10.0,
                3: 20.0,
                4: 30.0,
                5: 40.0,
                6: np.nan,
                7: 17.0,
                8: 20.0,
                9: 10.0,
                10: 20.0,
                11: 20000000.0,
                12: 30.0,
                13: 10.0,
                14: 20.0,
                15: 30.0,
                16: 100.0,
            },
            "volume": {
                0: 1.0,
                2: 2.0,
                3: 4.0,
                4: 6.0,
                5: 8.0,
                6: np.nan,
                7: 3.0,
                8: 4.0,
                9: 2.0,
                10: 4.0,
                11: np.nan,
                12: 6.0,
                13: 2.0,
                14: 4.0,
                15: 6.0,
                16: 10.0,
            },
        }
    )
    return df


def output_1_convert_dtype():
    df = pd.DataFrame(
        {
            "uid": {
                0: 1,
                2: 2,
                3: 3,
                4: 4,
                5: 5,
                6: 6,
                7: 7,
                8: 8,
                9: 9,
                10: 10,
                11: 11,
                12: 12,
                13: 13,
                14: 14,
                15: 15,
                16: 16,
            },
            "date": {
                0: pd.to_datetime("2019-12-31 00:00:00"),
                2: pd.to_datetime("2020-03-31 00:00:00"),
                3: pd.to_datetime("2020-03-31 00:00:00"),
                4: pd.to_datetime("2020-03-31 00:00:00"),
                5: pd.to_datetime("2020-03-31 00:00:00"),
                6: pd.to_datetime("2020-06-30 00:00:00"),
                7: pd.to_datetime("2020-06-30 00:00:00"),
                8: pd.to_datetime("2020-06-30 00:00:00"),
                9: pd.to_datetime("2020-09-30 00:00:00"),
                10: pd.to_datetime("2020-09-30 00:00:00"),
                11: pd.to_datetime("2020-09-30 00:00:00"),
                12: pd.to_datetime("2020-09-30 00:00:00"),
                13: pd.to_datetime("2020-12-31 00:00:00"),
                14: pd.to_datetime("2020-12-31 00:00:00"),
                15: pd.to_datetime("2020-12-31 00:00:00"),
                16: pd.to_datetime("2020-12-31 00:00:00"),
            },
            "id": {
                0: "A",
                2: "A",
                3: "B",
                4: "C",
                5: "na",
                6: "A",
                7: "E",
                8: "B",
                9: "A",
                10: "F",
                11: "B",
                12: "C",
                13: "A",
                14: "B",
                15: "C",
                16: "G",
            },
            "desc": {
                0: "this is A",
                2: "this is A",
                3: "this is B",
                4: "this is C",
                5: "",
                6: "this is A",
                7: "this is E",
                8: "this is B",
                9: "this is A",
                10: "this is F",
                11: "this is B",
                12: "this is C",
                13: "this is A",
                14: "this is B",
                15: "this is C",
                16: "this is G",
            },
            "value": {
                0: 5.0,
                2: 10.0,
                3: 20.0,
                4: 30.0,
                5: 40.0,
                6: np.nan,
                7: 17.0,
                8: 20.0,
                9: 10.0,
                10: 20.0,
                11: 20000000.0,
                12: 30.0,
                13: 10.0,
                14: 20.0,
                15: 30.0,
                16: 100.0,
            },
            "volume": {
                0: 1.0,
                2: 2.0,
                3: 4.0,
                4: 6.0,
                5: 8.0,
                6: np.nan,
                7: 3.0,
                8: 4.0,
                9: 2.0,
                10: 4.0,
                11: np.nan,
                12: 6.0,
                13: 2.0,
                14: 4.0,
                15: 6.0,
                16: 10.0,
            },
        }
    )
    return df


def output_1_clean_str_columns():
    df = pd.DataFrame(
        {
            "uid": {
                0: 1,
                2: 2,
                3: 3,
                4: 4,
                5: 5,
                6: 6,
                7: 7,
                8: 8,
                9: 9,
                10: 10,
                11: 11,
                12: 12,
                13: 13,
                14: 14,
                15: 15,
                16: 16,
            },
            "date": {
                0: pd.to_datetime("2019-12-31 00:00:00"),
                2: pd.to_datetime("2020-03-31 00:00:00"),
                3: pd.to_datetime("2020-03-31 00:00:00"),
                4: pd.to_datetime("2020-03-31 00:00:00"),
                5: pd.to_datetime("2020-03-31 00:00:00"),
                6: pd.to_datetime("2020-06-30 00:00:00"),
                7: pd.to_datetime("2020-06-30 00:00:00"),
                8: pd.to_datetime("2020-06-30 00:00:00"),
                9: pd.to_datetime("2020-09-30 00:00:00"),
                10: pd.to_datetime("2020-09-30 00:00:00"),
                11: pd.to_datetime("2020-09-30 00:00:00"),
                12: pd.to_datetime("2020-09-30 00:00:00"),
                13: pd.to_datetime("2020-12-31 00:00:00"),
                14: pd.to_datetime("2020-12-31 00:00:00"),
                15: pd.to_datetime("2020-12-31 00:00:00"),
                16: pd.to_datetime("2020-12-31 00:00:00"),
            },
            "id": {
                0: "A",
                2: "A",
                3: "B",
                4: "C",
                5: "na",
                6: "A",
                7: "E",
                8: "B",
                9: "A",
                10: "F",
                11: "B",
                12: "C",
                13: "A",
                14: "B",
                15: "C",
                16: "G",
            },
            "desc": {
                0: "a",
                2: "a",
                3: "b",
                4: "c",
                5: "",
                6: "a",
                7: "e",
                8: "b",
                9: "a",
                10: "f",
                11: "b",
                12: "c",
                13: "a",
                14: "b",
                15: "c",
                16: "g",
            },
            "value": {
                0: 5.0,
                2: 10.0,
                3: 20.0,
                4: 30.0,
                5: 40.0,
                6: np.nan,
                7: 17.0,
                8: 20.0,
                9: 10.0,
                10: 20.0,
                11: 20000000.0,
                12: 30.0,
                13: 10.0,
                14: 20.0,
                15: 30.0,
                16: 100.0,
            },
            "volume": {
                0: 1.0,
                2: 2.0,
                3: 4.0,
                4: 6.0,
                5: 8.0,
                6: np.nan,
                7: 3.0,
                8: 4.0,
                9: 2.0,
                10: 4.0,
                11: np.nan,
                12: 6.0,
                13: 2.0,
                14: 4.0,
                15: 6.0,
                16: 10.0,
            },
        }
    )
    return df


def output_1_fill_value_in_masked_entries():
    df = pd.DataFrame(
        {
            "uid": {
                0: 1,
                2: 2,
                3: 3,
                4: 4,
                5: 5,
                6: 6,
                7: 7,
                8: 8,
                9: 9,
                10: 10,
                11: 11,
                12: 12,
                13: 13,
                14: 14,
                15: 15,
                16: 16,
            },
            "date": {
                0: pd.to_datetime("2019-12-31 00:00:00"),
                2: pd.to_datetime("2020-03-31 00:00:00"),
                3: pd.to_datetime("2020-03-31 00:00:00"),
                4: pd.to_datetime("2020-03-31 00:00:00"),
                5: pd.to_datetime("2020-03-31 00:00:00"),
                6: pd.to_datetime("2020-06-30 00:00:00"),
                7: pd.to_datetime("2020-06-30 00:00:00"),
                8: pd.to_datetime("2020-06-30 00:00:00"),
                9: pd.to_datetime("2020-09-30 00:00:00"),
                10: pd.to_datetime("2020-09-30 00:00:00"),
                11: pd.to_datetime("2020-09-30 00:00:00"),
                12: pd.to_datetime("2020-09-30 00:00:00"),
                13: pd.to_datetime("2020-12-31 00:00:00"),
                14: pd.to_datetime("2020-12-31 00:00:00"),
                15: pd.to_datetime("2020-12-31 00:00:00"),
                16: pd.to_datetime("2020-12-31 00:00:00"),
            },
            "id": {
                0: "A",
                2: "A",
                3: "B",
                4: "C",
                5: np.nan,
                6: "A",
                7: "E",
                8: "B",
                9: "A",
                10: "F",
                11: "B",
                12: "C",
                13: "A",
                14: "B",
                15: "C",
                16: "G",
            },
            "desc": {
                0: "a",
                2: "a",
                3: "b",
                4: "c",
                5: np.nan,
                6: "a",
                7: "e",
                8: "b",
                9: "a",
                10: "f",
                11: "b",
                12: "c",
                13: "a",
                14: "b",
                15: "c",
                16: "g",
            },
            "value": {
                0: 5.0,
                2: 10.0,
                3: 20.0,
                4: 30.0,
                5: 40.0,
                6: np.nan,
                7: 17.0,
                8: 20.0,
                9: 10.0,
                10: 20.0,
                11: 20000000.0,
                12: 30.0,
                13: 10.0,
                14: 20.0,
                15: 30.0,
                16: 100.0,
            },
            "volume": {
                0: 1.0,
                2: 2.0,
                3: 4.0,
                4: 6.0,
                5: 8.0,
                6: np.nan,
                7: 3.0,
                8: 4.0,
                9: 2.0,
                10: 4.0,
                11: np.nan,
                12: 6.0,
                13: 2.0,
                14: 4.0,
                15: 6.0,
                16: 10.0,
            },
        }
    )
    return df


def output_1_drop_rows():
    df = pd.DataFrame(
        {
            "uid": {
                0: 1,
                2: 2,
                3: 3,
                4: 4,
                5: 5,
                7: 7,
                8: 8,
                9: 9,
                10: 10,
                11: 11,
                12: 12,
                13: 13,
                14: 14,
                15: 15,
                16: 16,
            },
            "date": {
                0: pd.to_datetime("2019-12-31 00:00:00"),
                2: pd.to_datetime("2020-03-31 00:00:00"),
                3: pd.to_datetime("2020-03-31 00:00:00"),
                4: pd.to_datetime("2020-03-31 00:00:00"),
                5: pd.to_datetime("2020-03-31 00:00:00"),
                7: pd.to_datetime("2020-06-30 00:00:00"),
                8: pd.to_datetime("2020-06-30 00:00:00"),
                9: pd.to_datetime("2020-09-30 00:00:00"),
                10: pd.to_datetime("2020-09-30 00:00:00"),
                11: pd.to_datetime("2020-09-30 00:00:00"),
                12: pd.to_datetime("2020-09-30 00:00:00"),
                13: pd.to_datetime("2020-12-31 00:00:00"),
                14: pd.to_datetime("2020-12-31 00:00:00"),
                15: pd.to_datetime("2020-12-31 00:00:00"),
                16: pd.to_datetime("2020-12-31 00:00:00"),
            },
            "id": {
                0: "A",
                2: "A",
                3: "B",
                4: "C",
                5: np.nan,
                7: "E",
                8: "B",
                9: "A",
                10: "F",
                11: "B",
                12: "C",
                13: "A",
                14: "B",
                15: "C",
                16: "G",
            },
            "desc": {
                0: "a",
                2: "a",
                3: "b",
                4: "c",
                5: np.nan,
                7: "e",
                8: "b",
                9: "a",
                10: "f",
                11: "b",
                12: "c",
                13: "a",
                14: "b",
                15: "c",
                16: "g",
            },
            "value": {
                0: 5.0,
                2: 10.0,
                3: 20.0,
                4: 30.0,
                5: 40.0,
                7: 17.0,
                8: 20.0,
                9: 10.0,
                10: 20.0,
                11: 20000000.0,
                12: 30.0,
                13: 10.0,
                14: 20.0,
                15: 30.0,
                16: 100.0,
            },
            "volume": {
                0: 1.0,
                2: 2.0,
                3: 4.0,
                4: 6.0,
                5: 8.0,
                7: 3.0,
                8: 4.0,
                9: 2.0,
                10: 4.0,
                11: np.nan,
                12: 6.0,
                13: 2.0,
                14: 4.0,
                15: 6.0,
                16: 10.0,
            },
        }
    )
    return df
